Package org.apache.sis.metadata.iso.identification

## Class DefaultResolution

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultResolution

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Resolution`

      public class DefaultResolution
      extends ISOMetadata
      implements Resolution

  Level of detail expressed as a scale factor or a ground distance. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
  `MD_Resolution` `├─angularDistance……` Angular sampling measure. `├─distance………………………` Ground sample distance. `├─equivalentScale……` Level of detail expressed as the scale of a comparable hardcopy map or chart. `│ └─denominator……` The number below the line in a vulgar fraction. `├─levelOfDetail…………` Brief textual description of the spatial resolution of the resource. `└─vertical………………………` Vertical sampling distance.
  ISO 19115 defines `Resolution` as an union (in the C/C++ sense): only one of the properties in this class can be set to a non-empty value. Setting any property to a non-empty value discard all the other ones. See the constructor javadoc for information about which property has precedence on copy operations.
  Limitations
  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    `AbstractIdentification​.getSpatialResolutions()`, Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultResolution()` | Constructs an initially empty resolution.
    `DefaultResolution​(RepresentativeFraction scale)` | Creates a new resolution initialized to the given scale.
    `DefaultResolution​(Resolution object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultResolution` | `castOrCopy​(Resolution object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Double` | `getAngularDistance()` | Returns the angular sampling measure.
    `Double` | `getDistance()` | Returns the ground sample distance.
    `RepresentativeFraction` | `getEquivalentScale()` | Returns the level of detail expressed as the scale of a comparable hardcopy map or chart.
    `InternationalString` | `getLevelOfDetail()` | Returns a brief textual description of the spatial resolution of the resource.
    `Double` | `getVertical()` | Returns the vertical sampling distance.
    `void` | `setAngularDistance​(Double newValue)` | Sets the angular sampling measure.
    `void` | `setDistance​(Double newValue)` | Sets the ground sample distance.
    `void` | `setEquivalentScale​(RepresentativeFraction newValue)` | Sets the level of detail expressed as the scale of a comparable hardcopy map or chart.
    `void` | `setLevelOfDetail​(InternationalString newValue)` | Sets the textual description of the spatial resolution of the resource.
    `void` | `setVertical​(Double newValue)` | Sets the vertical sampling distance.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultResolution

          public DefaultResolution()

      Constructs an initially empty resolution.

    - #### DefaultResolution

          public DefaultResolution​(RepresentativeFraction scale)

      Creates a new resolution initialized to the given scale.
      Parameters:
        `scale` - the scale, or `null` if none.
      Since:
        0.4

    - #### DefaultResolution

          public DefaultResolution​(Resolution object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.

      If more than one of the equivalent scale, distance, vertical, angular distance and level of detail are specified, then the first of those values is taken and the other values are silently discarded.

      Note on properties validation: This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(Resolution)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultResolution castOrCopy​(Resolution object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultResolution`, then it is returned unchanged.
      - Otherwise a new `DefaultResolution` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getEquivalentScale

          public RepresentativeFraction getEquivalentScale()

      Returns the level of detail expressed as the scale of a comparable hardcopy map or chart.
      Specified by:
        `getEquivalentScale` in interface `Resolution`
      Returns:
        level of detail expressed as the scale of a comparable hardcopy, or `null`.

    - #### setEquivalentScale

          public void setEquivalentScale​(RepresentativeFraction newValue)

      Sets the level of detail expressed as the scale of a comparable hardcopy map or chart.
      Effect on other properties
      If and only if the `newValue` is non-null, then this method automatically discards all other properties.
      Parameters:
        `newValue` - the new equivalent scale.

    - #### getDistance

          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          public Double getDistance()

      Returns the ground sample distance.
      Specified by:
        `getDistance` in interface `Resolution`
      Returns:
        the ground sample distance, or `null`.

    - #### setDistance

          public void setDistance​(Double newValue)

      Sets the ground sample distance.
      Effect on other properties
      If and only if the `newValue` is non-null, then this method automatically discards all other properties.
      Parameters:
        `newValue` - the new distance, or `null`.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.

    - #### getVertical

          @UML(identifier="vertical",
               obligation=CONDITIONAL,
               specification=ISO_19115)
          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          public Double getVertical()

      Returns the vertical sampling distance.
      Returns:
        the vertical sampling distance, or `null`.
      Since:
        0.5

    - #### setVertical

          public void setVertical​(Double newValue)

      Sets the vertical sampling distance.
      Effect on other properties
      If and only if the `newValue` is non-null, then this method automatically discards all other properties.
      Parameters:
        `newValue` - the new distance, or `null`.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.
      Since:
        0.5

    - #### getAngularDistance

          @UML(identifier="angularDistance",
               obligation=CONDITIONAL,
               specification=ISO_19115)
          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          public Double getAngularDistance()

      Returns the angular sampling measure.
      Returns:
        the angular sampling measure, or `null`.
      Since:
        0.5

    - #### setAngularDistance

          public void setAngularDistance​(Double newValue)

      Sets the angular sampling measure.
      Effect on other properties
      If and only if the `newValue` is non-null, then this method automatically discards all other properties.
      Parameters:
        `newValue` - the new distance, or `null`.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.
      Since:
        0.5

    - #### getLevelOfDetail

          @UML(identifier="levelOfDetail",
               obligation=CONDITIONAL,
               specification=ISO_19115)
          public InternationalString getLevelOfDetail()

      Returns a brief textual description of the spatial resolution of the resource.
      Returns:
        textual description of the spatial resolution, or `null`.
      Since:
        0.5

    - #### setLevelOfDetail

          public void setLevelOfDetail​(InternationalString newValue)

      Sets the textual description of the spatial resolution of the resource.
      Effect on other properties
      If and only if the `newValue` is non-null, then this method automatically discards all other properties.
      Parameters:
        `newValue` - the new distance.
      Since:
        0.5